// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_msgs:msg/FloorData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__FLOOR_DATA__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__FLOOR_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'floor_center'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__msg__FloorData __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__msg__FloorData __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FloorData_
{
  using Type = FloorData_<ContainerAllocator>;

  explicit FloorData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    floor_center(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  explicit FloorData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    floor_center(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _floor_center_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _floor_center_type floor_center;
  using _keyframe_ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _keyframe_ids_type keyframe_ids;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__floor_center(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->floor_center = _arg;
    return *this;
  }
  Type & set__keyframe_ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->keyframe_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::msg::FloorData_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::msg::FloorData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::FloorData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::FloorData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__msg__FloorData
    std::shared_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__msg__FloorData
    std::shared_ptr<situational_graphs_msgs::msg::FloorData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FloorData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->floor_center != other.floor_center) {
      return false;
    }
    if (this->keyframe_ids != other.keyframe_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const FloorData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FloorData_

// alias to use template instance with default allocator
using FloorData =
  situational_graphs_msgs::msg::FloorData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__FLOOR_DATA__STRUCT_HPP_
