// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from situational_graphs_msgs:msg/PlaneData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__BUILDER_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "situational_graphs_msgs/msg/detail/plane_data__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace situational_graphs_msgs
{

namespace msg
{

namespace builder
{

class Init_PlaneData_data_source
{
public:
  explicit Init_PlaneData_data_source(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  ::situational_graphs_msgs::msg::PlaneData data_source(::situational_graphs_msgs::msg::PlaneData::_data_source_type arg)
  {
    msg_.data_source = std::move(arg);
    return std::move(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_plane_points
{
public:
  explicit Init_PlaneData_plane_points(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_data_source plane_points(::situational_graphs_msgs::msg::PlaneData::_plane_points_type arg)
  {
    msg_.plane_points = std::move(arg);
    return Init_PlaneData_data_source(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_plane_orientation
{
public:
  explicit Init_PlaneData_plane_orientation(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_plane_points plane_orientation(::situational_graphs_msgs::msg::PlaneData::_plane_orientation_type arg)
  {
    msg_.plane_orientation = std::move(arg);
    return Init_PlaneData_plane_points(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_d
{
public:
  explicit Init_PlaneData_d(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_plane_orientation d(::situational_graphs_msgs::msg::PlaneData::_d_type arg)
  {
    msg_.d = std::move(arg);
    return Init_PlaneData_plane_orientation(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_nz
{
public:
  explicit Init_PlaneData_nz(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_d nz(::situational_graphs_msgs::msg::PlaneData::_nz_type arg)
  {
    msg_.nz = std::move(arg);
    return Init_PlaneData_d(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_ny
{
public:
  explicit Init_PlaneData_ny(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_nz ny(::situational_graphs_msgs::msg::PlaneData::_ny_type arg)
  {
    msg_.ny = std::move(arg);
    return Init_PlaneData_nz(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_nx
{
public:
  explicit Init_PlaneData_nx(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_ny nx(::situational_graphs_msgs::msg::PlaneData::_nx_type arg)
  {
    msg_.nx = std::move(arg);
    return Init_PlaneData_ny(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_id
{
public:
  explicit Init_PlaneData_id(::situational_graphs_msgs::msg::PlaneData & msg)
  : msg_(msg)
  {}
  Init_PlaneData_nx id(::situational_graphs_msgs::msg::PlaneData::_id_type arg)
  {
    msg_.id = std::move(arg);
    return Init_PlaneData_nx(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

class Init_PlaneData_header
{
public:
  Init_PlaneData_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlaneData_id header(::situational_graphs_msgs::msg::PlaneData::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_PlaneData_id(msg_);
  }

private:
  ::situational_graphs_msgs::msg::PlaneData msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::situational_graphs_msgs::msg::PlaneData>()
{
  return situational_graphs_msgs::msg::builder::Init_PlaneData_header();
}

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__BUILDER_HPP_
