// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_msgs:msg/PlaneData.idl
// generated code does not contain a copyright notice
#include "situational_graphs_msgs/msg/detail/plane_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `plane_orientation`
// Member `plane_points`
#include "geometry_msgs/msg/detail/vector3__functions.h"
// Member `data_source`
#include "rosidl_runtime_c/string_functions.h"

bool
situational_graphs_msgs__msg__PlaneData__init(situational_graphs_msgs__msg__PlaneData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    situational_graphs_msgs__msg__PlaneData__fini(msg);
    return false;
  }
  // id
  // nx
  // ny
  // nz
  // d
  // plane_orientation
  if (!geometry_msgs__msg__Vector3__init(&msg->plane_orientation)) {
    situational_graphs_msgs__msg__PlaneData__fini(msg);
    return false;
  }
  // plane_points
  if (!geometry_msgs__msg__Vector3__Sequence__init(&msg->plane_points, 0)) {
    situational_graphs_msgs__msg__PlaneData__fini(msg);
    return false;
  }
  // data_source
  if (!rosidl_runtime_c__String__init(&msg->data_source)) {
    situational_graphs_msgs__msg__PlaneData__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_msgs__msg__PlaneData__fini(situational_graphs_msgs__msg__PlaneData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // nx
  // ny
  // nz
  // d
  // plane_orientation
  geometry_msgs__msg__Vector3__fini(&msg->plane_orientation);
  // plane_points
  geometry_msgs__msg__Vector3__Sequence__fini(&msg->plane_points);
  // data_source
  rosidl_runtime_c__String__fini(&msg->data_source);
}

bool
situational_graphs_msgs__msg__PlaneData__are_equal(const situational_graphs_msgs__msg__PlaneData * lhs, const situational_graphs_msgs__msg__PlaneData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // nx
  if (lhs->nx != rhs->nx) {
    return false;
  }
  // ny
  if (lhs->ny != rhs->ny) {
    return false;
  }
  // nz
  if (lhs->nz != rhs->nz) {
    return false;
  }
  // d
  if (lhs->d != rhs->d) {
    return false;
  }
  // plane_orientation
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->plane_orientation), &(rhs->plane_orientation)))
  {
    return false;
  }
  // plane_points
  if (!geometry_msgs__msg__Vector3__Sequence__are_equal(
      &(lhs->plane_points), &(rhs->plane_points)))
  {
    return false;
  }
  // data_source
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data_source), &(rhs->data_source)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_msgs__msg__PlaneData__copy(
  const situational_graphs_msgs__msg__PlaneData * input,
  situational_graphs_msgs__msg__PlaneData * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // nx
  output->nx = input->nx;
  // ny
  output->ny = input->ny;
  // nz
  output->nz = input->nz;
  // d
  output->d = input->d;
  // plane_orientation
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->plane_orientation), &(output->plane_orientation)))
  {
    return false;
  }
  // plane_points
  if (!geometry_msgs__msg__Vector3__Sequence__copy(
      &(input->plane_points), &(output->plane_points)))
  {
    return false;
  }
  // data_source
  if (!rosidl_runtime_c__String__copy(
      &(input->data_source), &(output->data_source)))
  {
    return false;
  }
  return true;
}

situational_graphs_msgs__msg__PlaneData *
situational_graphs_msgs__msg__PlaneData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlaneData * msg = (situational_graphs_msgs__msg__PlaneData *)allocator.allocate(sizeof(situational_graphs_msgs__msg__PlaneData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_msgs__msg__PlaneData));
  bool success = situational_graphs_msgs__msg__PlaneData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_msgs__msg__PlaneData__destroy(situational_graphs_msgs__msg__PlaneData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_msgs__msg__PlaneData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_msgs__msg__PlaneData__Sequence__init(situational_graphs_msgs__msg__PlaneData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlaneData * data = NULL;

  if (size) {
    data = (situational_graphs_msgs__msg__PlaneData *)allocator.zero_allocate(size, sizeof(situational_graphs_msgs__msg__PlaneData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_msgs__msg__PlaneData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_msgs__msg__PlaneData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_msgs__msg__PlaneData__Sequence__fini(situational_graphs_msgs__msg__PlaneData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_msgs__msg__PlaneData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_msgs__msg__PlaneData__Sequence *
situational_graphs_msgs__msg__PlaneData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlaneData__Sequence * array = (situational_graphs_msgs__msg__PlaneData__Sequence *)allocator.allocate(sizeof(situational_graphs_msgs__msg__PlaneData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_msgs__msg__PlaneData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_msgs__msg__PlaneData__Sequence__destroy(situational_graphs_msgs__msg__PlaneData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_msgs__msg__PlaneData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_msgs__msg__PlaneData__Sequence__are_equal(const situational_graphs_msgs__msg__PlaneData__Sequence * lhs, const situational_graphs_msgs__msg__PlaneData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_msgs__msg__PlaneData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_msgs__msg__PlaneData__Sequence__copy(
  const situational_graphs_msgs__msg__PlaneData__Sequence * input,
  situational_graphs_msgs__msg__PlaneData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_msgs__msg__PlaneData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_msgs__msg__PlaneData * data =
      (situational_graphs_msgs__msg__PlaneData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_msgs__msg__PlaneData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_msgs__msg__PlaneData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_msgs__msg__PlaneData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
