// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_msgs:msg/PlaneData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'plane_orientation'
// Member 'plane_points'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__msg__PlaneData __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__msg__PlaneData __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PlaneData_
{
  using Type = PlaneData_<ContainerAllocator>;

  explicit PlaneData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    plane_orientation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->nx = 0.0f;
      this->ny = 0.0f;
      this->nz = 0.0f;
      this->d = 0.0f;
      this->data_source = "";
    }
  }

  explicit PlaneData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    plane_orientation(_alloc, _init),
    data_source(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->nx = 0.0f;
      this->ny = 0.0f;
      this->nz = 0.0f;
      this->d = 0.0f;
      this->data_source = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _nx_type =
    float;
  _nx_type nx;
  using _ny_type =
    float;
  _ny_type ny;
  using _nz_type =
    float;
  _nz_type nz;
  using _d_type =
    float;
  _d_type d;
  using _plane_orientation_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _plane_orientation_type plane_orientation;
  using _plane_points_type =
    std::vector<geometry_msgs::msg::Vector3_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Vector3_<ContainerAllocator>>>;
  _plane_points_type plane_points;
  using _data_source_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_source_type data_source;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__nx(
    const float & _arg)
  {
    this->nx = _arg;
    return *this;
  }
  Type & set__ny(
    const float & _arg)
  {
    this->ny = _arg;
    return *this;
  }
  Type & set__nz(
    const float & _arg)
  {
    this->nz = _arg;
    return *this;
  }
  Type & set__d(
    const float & _arg)
  {
    this->d = _arg;
    return *this;
  }
  Type & set__plane_orientation(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->plane_orientation = _arg;
    return *this;
  }
  Type & set__plane_points(
    const std::vector<geometry_msgs::msg::Vector3_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Vector3_<ContainerAllocator>>> & _arg)
  {
    this->plane_points = _arg;
    return *this;
  }
  Type & set__data_source(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data_source = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__msg__PlaneData
    std::shared_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__msg__PlaneData
    std::shared_ptr<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PlaneData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->nx != other.nx) {
      return false;
    }
    if (this->ny != other.ny) {
      return false;
    }
    if (this->nz != other.nz) {
      return false;
    }
    if (this->d != other.d) {
      return false;
    }
    if (this->plane_orientation != other.plane_orientation) {
      return false;
    }
    if (this->plane_points != other.plane_points) {
      return false;
    }
    if (this->data_source != other.data_source) {
      return false;
    }
    return true;
  }
  bool operator!=(const PlaneData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PlaneData_

// alias to use template instance with default allocator
using PlaneData =
  situational_graphs_msgs::msg::PlaneData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__STRUCT_HPP_
