// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_msgs:msg/PlaneData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_msgs/msg/detail/plane_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'plane_orientation'
// Member 'plane_points'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace situational_graphs_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PlaneData & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: nx
  {
    out << "nx: ";
    rosidl_generator_traits::value_to_yaml(msg.nx, out);
    out << ", ";
  }

  // member: ny
  {
    out << "ny: ";
    rosidl_generator_traits::value_to_yaml(msg.ny, out);
    out << ", ";
  }

  // member: nz
  {
    out << "nz: ";
    rosidl_generator_traits::value_to_yaml(msg.nz, out);
    out << ", ";
  }

  // member: d
  {
    out << "d: ";
    rosidl_generator_traits::value_to_yaml(msg.d, out);
    out << ", ";
  }

  // member: plane_orientation
  {
    out << "plane_orientation: ";
    to_flow_style_yaml(msg.plane_orientation, out);
    out << ", ";
  }

  // member: plane_points
  {
    if (msg.plane_points.size() == 0) {
      out << "plane_points: []";
    } else {
      out << "plane_points: [";
      size_t pending_items = msg.plane_points.size();
      for (auto item : msg.plane_points) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: data_source
  {
    out << "data_source: ";
    rosidl_generator_traits::value_to_yaml(msg.data_source, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlaneData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: nx
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nx: ";
    rosidl_generator_traits::value_to_yaml(msg.nx, out);
    out << "\n";
  }

  // member: ny
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ny: ";
    rosidl_generator_traits::value_to_yaml(msg.ny, out);
    out << "\n";
  }

  // member: nz
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "nz: ";
    rosidl_generator_traits::value_to_yaml(msg.nz, out);
    out << "\n";
  }

  // member: d
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "d: ";
    rosidl_generator_traits::value_to_yaml(msg.d, out);
    out << "\n";
  }

  // member: plane_orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "plane_orientation:\n";
    to_block_style_yaml(msg.plane_orientation, out, indentation + 2);
  }

  // member: plane_points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.plane_points.size() == 0) {
      out << "plane_points: []\n";
    } else {
      out << "plane_points:\n";
      for (auto item : msg.plane_points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: data_source
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_source: ";
    rosidl_generator_traits::value_to_yaml(msg.data_source, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlaneData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::msg::PlaneData & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::msg::PlaneData & msg)
{
  return situational_graphs_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::msg::PlaneData>()
{
  return "situational_graphs_msgs::msg::PlaneData";
}

template<>
inline const char * name<situational_graphs_msgs::msg::PlaneData>()
{
  return "situational_graphs_msgs/msg/PlaneData";
}

template<>
struct has_fixed_size<situational_graphs_msgs::msg::PlaneData>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::msg::PlaneData>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_msgs::msg::PlaneData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANE_DATA__TRAITS_HPP_
