// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_msgs:msg/PlanesData.idl
// generated code does not contain a copyright notice
#include "situational_graphs_msgs/msg/detail/planes_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `x_planes`
// Member `y_planes`
#include "situational_graphs_msgs/msg/detail/plane_data__functions.h"

bool
situational_graphs_msgs__msg__PlanesData__init(situational_graphs_msgs__msg__PlanesData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    situational_graphs_msgs__msg__PlanesData__fini(msg);
    return false;
  }
  // x_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__init(&msg->x_planes, 0)) {
    situational_graphs_msgs__msg__PlanesData__fini(msg);
    return false;
  }
  // y_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__init(&msg->y_planes, 0)) {
    situational_graphs_msgs__msg__PlanesData__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_msgs__msg__PlanesData__fini(situational_graphs_msgs__msg__PlanesData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // x_planes
  situational_graphs_msgs__msg__PlaneData__Sequence__fini(&msg->x_planes);
  // y_planes
  situational_graphs_msgs__msg__PlaneData__Sequence__fini(&msg->y_planes);
}

bool
situational_graphs_msgs__msg__PlanesData__are_equal(const situational_graphs_msgs__msg__PlanesData * lhs, const situational_graphs_msgs__msg__PlanesData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // x_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__are_equal(
      &(lhs->x_planes), &(rhs->x_planes)))
  {
    return false;
  }
  // y_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__are_equal(
      &(lhs->y_planes), &(rhs->y_planes)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_msgs__msg__PlanesData__copy(
  const situational_graphs_msgs__msg__PlanesData * input,
  situational_graphs_msgs__msg__PlanesData * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // x_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__copy(
      &(input->x_planes), &(output->x_planes)))
  {
    return false;
  }
  // y_planes
  if (!situational_graphs_msgs__msg__PlaneData__Sequence__copy(
      &(input->y_planes), &(output->y_planes)))
  {
    return false;
  }
  return true;
}

situational_graphs_msgs__msg__PlanesData *
situational_graphs_msgs__msg__PlanesData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlanesData * msg = (situational_graphs_msgs__msg__PlanesData *)allocator.allocate(sizeof(situational_graphs_msgs__msg__PlanesData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_msgs__msg__PlanesData));
  bool success = situational_graphs_msgs__msg__PlanesData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_msgs__msg__PlanesData__destroy(situational_graphs_msgs__msg__PlanesData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_msgs__msg__PlanesData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_msgs__msg__PlanesData__Sequence__init(situational_graphs_msgs__msg__PlanesData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlanesData * data = NULL;

  if (size) {
    data = (situational_graphs_msgs__msg__PlanesData *)allocator.zero_allocate(size, sizeof(situational_graphs_msgs__msg__PlanesData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_msgs__msg__PlanesData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_msgs__msg__PlanesData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_msgs__msg__PlanesData__Sequence__fini(situational_graphs_msgs__msg__PlanesData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_msgs__msg__PlanesData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_msgs__msg__PlanesData__Sequence *
situational_graphs_msgs__msg__PlanesData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__PlanesData__Sequence * array = (situational_graphs_msgs__msg__PlanesData__Sequence *)allocator.allocate(sizeof(situational_graphs_msgs__msg__PlanesData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_msgs__msg__PlanesData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_msgs__msg__PlanesData__Sequence__destroy(situational_graphs_msgs__msg__PlanesData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_msgs__msg__PlanesData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_msgs__msg__PlanesData__Sequence__are_equal(const situational_graphs_msgs__msg__PlanesData__Sequence * lhs, const situational_graphs_msgs__msg__PlanesData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_msgs__msg__PlanesData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_msgs__msg__PlanesData__Sequence__copy(
  const situational_graphs_msgs__msg__PlanesData__Sequence * input,
  situational_graphs_msgs__msg__PlanesData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_msgs__msg__PlanesData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_msgs__msg__PlanesData * data =
      (situational_graphs_msgs__msg__PlanesData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_msgs__msg__PlanesData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_msgs__msg__PlanesData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_msgs__msg__PlanesData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
