// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from situational_graphs_msgs:msg/PointClouds.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__FUNCTIONS_H_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "situational_graphs_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "situational_graphs_msgs/msg/detail/point_clouds__struct.h"

/// Initialize msg/PointClouds message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * situational_graphs_msgs__msg__PointClouds
 * )) before or use
 * situational_graphs_msgs__msg__PointClouds__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__init(situational_graphs_msgs__msg__PointClouds * msg);

/// Finalize msg/PointClouds message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
void
situational_graphs_msgs__msg__PointClouds__fini(situational_graphs_msgs__msg__PointClouds * msg);

/// Create msg/PointClouds message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * situational_graphs_msgs__msg__PointClouds__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
situational_graphs_msgs__msg__PointClouds *
situational_graphs_msgs__msg__PointClouds__create();

/// Destroy msg/PointClouds message.
/**
 * It calls
 * situational_graphs_msgs__msg__PointClouds__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
void
situational_graphs_msgs__msg__PointClouds__destroy(situational_graphs_msgs__msg__PointClouds * msg);

/// Check for msg/PointClouds message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__are_equal(const situational_graphs_msgs__msg__PointClouds * lhs, const situational_graphs_msgs__msg__PointClouds * rhs);

/// Copy a msg/PointClouds message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__copy(
  const situational_graphs_msgs__msg__PointClouds * input,
  situational_graphs_msgs__msg__PointClouds * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
const rosidl_type_hash_t *
situational_graphs_msgs__msg__PointClouds__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
const rosidl_runtime_c__type_description__TypeDescription *
situational_graphs_msgs__msg__PointClouds__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
const rosidl_runtime_c__type_description__TypeSource *
situational_graphs_msgs__msg__PointClouds__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
situational_graphs_msgs__msg__PointClouds__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/PointClouds messages.
/**
 * It allocates the memory for the number of elements and calls
 * situational_graphs_msgs__msg__PointClouds__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__Sequence__init(situational_graphs_msgs__msg__PointClouds__Sequence * array, size_t size);

/// Finalize array of msg/PointClouds messages.
/**
 * It calls
 * situational_graphs_msgs__msg__PointClouds__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
void
situational_graphs_msgs__msg__PointClouds__Sequence__fini(situational_graphs_msgs__msg__PointClouds__Sequence * array);

/// Create array of msg/PointClouds messages.
/**
 * It allocates the memory for the array and calls
 * situational_graphs_msgs__msg__PointClouds__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
situational_graphs_msgs__msg__PointClouds__Sequence *
situational_graphs_msgs__msg__PointClouds__Sequence__create(size_t size);

/// Destroy array of msg/PointClouds messages.
/**
 * It calls
 * situational_graphs_msgs__msg__PointClouds__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
void
situational_graphs_msgs__msg__PointClouds__Sequence__destroy(situational_graphs_msgs__msg__PointClouds__Sequence * array);

/// Check for msg/PointClouds message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__Sequence__are_equal(const situational_graphs_msgs__msg__PointClouds__Sequence * lhs, const situational_graphs_msgs__msg__PointClouds__Sequence * rhs);

/// Copy an array of msg/PointClouds messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_msgs
bool
situational_graphs_msgs__msg__PointClouds__Sequence__copy(
  const situational_graphs_msgs__msg__PointClouds__Sequence * input,
  situational_graphs_msgs__msg__PointClouds__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__FUNCTIONS_H_
