// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_msgs:msg/RoomData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'room_length'
// Member 'cluster_center'
#include "geometry_msgs/msg/detail/point__struct.hpp"
// Member 'room_center'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'x_planes'
// Member 'y_planes'
#include "situational_graphs_msgs/msg/detail/plane_data__struct.hpp"
// Member 'cluster_array'
#include "visualization_msgs/msg/detail/marker_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__msg__RoomData __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__msg__RoomData __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoomData_
{
  using Type = RoomData_<ContainerAllocator>;

  explicit RoomData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    room_length(_init),
    room_center(_init),
    cluster_center(_init),
    cluster_array(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  explicit RoomData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    room_length(_alloc, _init),
    room_center(_alloc, _init),
    cluster_center(_alloc, _init),
    cluster_array(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _neighbour_ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _neighbour_ids_type neighbour_ids;
  using _room_length_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _room_length_type room_length;
  using _room_center_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _room_center_type room_center;
  using _cluster_center_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _cluster_center_type cluster_center;
  using _x_planes_type =
    std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>;
  _x_planes_type x_planes;
  using _y_planes_type =
    std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>;
  _y_planes_type y_planes;
  using _cluster_array_type =
    visualization_msgs::msg::MarkerArray_<ContainerAllocator>;
  _cluster_array_type cluster_array;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__neighbour_ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->neighbour_ids = _arg;
    return *this;
  }
  Type & set__room_length(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->room_length = _arg;
    return *this;
  }
  Type & set__room_center(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->room_center = _arg;
    return *this;
  }
  Type & set__cluster_center(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->cluster_center = _arg;
    return *this;
  }
  Type & set__x_planes(
    const std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>> & _arg)
  {
    this->x_planes = _arg;
    return *this;
  }
  Type & set__y_planes(
    const std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>> & _arg)
  {
    this->y_planes = _arg;
    return *this;
  }
  Type & set__cluster_array(
    const visualization_msgs::msg::MarkerArray_<ContainerAllocator> & _arg)
  {
    this->cluster_array = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::msg::RoomData_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::msg::RoomData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::RoomData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::RoomData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__msg__RoomData
    std::shared_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__msg__RoomData
    std::shared_ptr<situational_graphs_msgs::msg::RoomData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoomData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->neighbour_ids != other.neighbour_ids) {
      return false;
    }
    if (this->room_length != other.room_length) {
      return false;
    }
    if (this->room_center != other.room_center) {
      return false;
    }
    if (this->cluster_center != other.cluster_center) {
      return false;
    }
    if (this->x_planes != other.x_planes) {
      return false;
    }
    if (this->y_planes != other.y_planes) {
      return false;
    }
    if (this->cluster_array != other.cluster_array) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoomData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoomData_

// alias to use template instance with default allocator
using RoomData =
  situational_graphs_msgs::msg::RoomData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_HPP_
