// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_msgs:msg/WallData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__WALL_DATA__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__WALL_DATA__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'wall_center'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'wall_point'
#include "geometry_msgs/msg/detail/point__struct.hpp"
// Member 'x_planes'
// Member 'y_planes'
#include "situational_graphs_msgs/msg/detail/plane_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__msg__WallData __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__msg__WallData __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WallData_
{
  using Type = WallData_<ContainerAllocator>;

  explicit WallData_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    wall_center(_init),
    wall_point(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  explicit WallData_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    wall_center(_alloc, _init),
    wall_point(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _wall_center_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _wall_center_type wall_center;
  using _wall_point_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _wall_point_type wall_point;
  using _x_planes_type =
    std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>;
  _x_planes_type x_planes;
  using _y_planes_type =
    std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>>;
  _y_planes_type y_planes;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__wall_center(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->wall_center = _arg;
    return *this;
  }
  Type & set__wall_point(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->wall_point = _arg;
    return *this;
  }
  Type & set__x_planes(
    const std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>> & _arg)
  {
    this->x_planes = _arg;
    return *this;
  }
  Type & set__y_planes(
    const std::vector<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::msg::PlaneData_<ContainerAllocator>>> & _arg)
  {
    this->y_planes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::msg::WallData_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::msg::WallData_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::WallData_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::msg::WallData_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__msg__WallData
    std::shared_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__msg__WallData
    std::shared_ptr<situational_graphs_msgs::msg::WallData_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WallData_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->wall_center != other.wall_center) {
      return false;
    }
    if (this->wall_point != other.wall_point) {
      return false;
    }
    if (this->x_planes != other.x_planes) {
      return false;
    }
    if (this->y_planes != other.y_planes) {
      return false;
    }
    return true;
  }
  bool operator!=(const WallData_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WallData_

// alias to use template instance with default allocator
using WallData =
  situational_graphs_msgs::msg::WallData_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__WALL_DATA__STRUCT_HPP_
