// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_msgs:srv/SaveMap.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_msgs/srv/detail/save_map__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace situational_graphs_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SaveMap_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: utm
  {
    out << "utm: ";
    rosidl_generator_traits::value_to_yaml(msg.utm, out);
    out << ", ";
  }

  // member: resolution
  {
    out << "resolution: ";
    rosidl_generator_traits::value_to_yaml(msg.resolution, out);
    out << ", ";
  }

  // member: destination
  {
    out << "destination: ";
    rosidl_generator_traits::value_to_yaml(msg.destination, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SaveMap_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: utm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "utm: ";
    rosidl_generator_traits::value_to_yaml(msg.utm, out);
    out << "\n";
  }

  // member: resolution
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "resolution: ";
    rosidl_generator_traits::value_to_yaml(msg.resolution, out);
    out << "\n";
  }

  // member: destination
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "destination: ";
    rosidl_generator_traits::value_to_yaml(msg.destination, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SaveMap_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::srv::SaveMap_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::srv::SaveMap_Request & msg)
{
  return situational_graphs_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::srv::SaveMap_Request>()
{
  return "situational_graphs_msgs::srv::SaveMap_Request";
}

template<>
inline const char * name<situational_graphs_msgs::srv::SaveMap_Request>()
{
  return "situational_graphs_msgs/srv/SaveMap_Request";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::SaveMap_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::SaveMap_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_msgs::srv::SaveMap_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace situational_graphs_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SaveMap_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SaveMap_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SaveMap_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::srv::SaveMap_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::srv::SaveMap_Response & msg)
{
  return situational_graphs_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::srv::SaveMap_Response>()
{
  return "situational_graphs_msgs::srv::SaveMap_Response";
}

template<>
inline const char * name<situational_graphs_msgs::srv::SaveMap_Response>()
{
  return "situational_graphs_msgs/srv/SaveMap_Response";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::SaveMap_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::SaveMap_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<situational_graphs_msgs::srv::SaveMap_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace situational_graphs_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SaveMap_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SaveMap_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SaveMap_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::srv::SaveMap_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::srv::SaveMap_Event & msg)
{
  return situational_graphs_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::srv::SaveMap_Event>()
{
  return "situational_graphs_msgs::srv::SaveMap_Event";
}

template<>
inline const char * name<situational_graphs_msgs::srv::SaveMap_Event>()
{
  return "situational_graphs_msgs/srv/SaveMap_Event";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::SaveMap_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::SaveMap_Event>
  : std::integral_constant<bool, has_bounded_size<service_msgs::msg::ServiceEventInfo>::value && has_bounded_size<situational_graphs_msgs::srv::SaveMap_Request>::value && has_bounded_size<situational_graphs_msgs::srv::SaveMap_Response>::value> {};

template<>
struct is_message<situational_graphs_msgs::srv::SaveMap_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<situational_graphs_msgs::srv::SaveMap>()
{
  return "situational_graphs_msgs::srv::SaveMap";
}

template<>
inline const char * name<situational_graphs_msgs::srv::SaveMap>()
{
  return "situational_graphs_msgs/srv/SaveMap";
}

template<>
struct has_fixed_size<situational_graphs_msgs::srv::SaveMap>
  : std::integral_constant<
    bool,
    has_fixed_size<situational_graphs_msgs::srv::SaveMap_Request>::value &&
    has_fixed_size<situational_graphs_msgs::srv::SaveMap_Response>::value
  >
{
};

template<>
struct has_bounded_size<situational_graphs_msgs::srv::SaveMap>
  : std::integral_constant<
    bool,
    has_bounded_size<situational_graphs_msgs::srv::SaveMap_Request>::value &&
    has_bounded_size<situational_graphs_msgs::srv::SaveMap_Response>::value
  >
{
};

template<>
struct is_service<situational_graphs_msgs::srv::SaveMap>
  : std::true_type
{
};

template<>
struct is_service_request<situational_graphs_msgs::srv::SaveMap_Request>
  : std::true_type
{
};

template<>
struct is_service_response<situational_graphs_msgs::srv::SaveMap_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__TRAITS_HPP_
