// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_msgs:msg/PlanesData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANES_DATA__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANES_DATA__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_msgs/msg/detail/planes_data__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'x_planes'
// Member 'y_planes'
#include "situational_graphs_msgs/msg/detail/plane_data__traits.hpp"

namespace situational_graphs_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PlanesData & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: x_planes
  {
    if (msg.x_planes.size() == 0) {
      out << "x_planes: []";
    } else {
      out << "x_planes: [";
      size_t pending_items = msg.x_planes.size();
      for (auto item : msg.x_planes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: y_planes
  {
    if (msg.y_planes.size() == 0) {
      out << "y_planes: []";
    } else {
      out << "y_planes: [";
      size_t pending_items = msg.y_planes.size();
      for (auto item : msg.y_planes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PlanesData & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: x_planes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.x_planes.size() == 0) {
      out << "x_planes: []\n";
    } else {
      out << "x_planes:\n";
      for (auto item : msg.x_planes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: y_planes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.y_planes.size() == 0) {
      out << "y_planes: []\n";
    } else {
      out << "y_planes:\n";
      for (auto item : msg.y_planes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PlanesData & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::msg::PlanesData & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::msg::PlanesData & msg)
{
  return situational_graphs_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::msg::PlanesData>()
{
  return "situational_graphs_msgs::msg::PlanesData";
}

template<>
inline const char * name<situational_graphs_msgs::msg::PlanesData>()
{
  return "situational_graphs_msgs/msg/PlanesData";
}

template<>
struct has_fixed_size<situational_graphs_msgs::msg::PlanesData>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::msg::PlanesData>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_msgs::msg::PlanesData>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__PLANES_DATA__TRAITS_HPP_
