// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_msgs:msg/PointClouds.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_msgs/msg/detail/point_clouds__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pointclouds'
#include "sensor_msgs/msg/detail/point_cloud2__traits.hpp"

namespace situational_graphs_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PointClouds & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: pointclouds
  {
    if (msg.pointclouds.size() == 0) {
      out << "pointclouds: []";
    } else {
      out << "pointclouds: [";
      size_t pending_items = msg.pointclouds.size();
      for (auto item : msg.pointclouds) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PointClouds & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: pointclouds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.pointclouds.size() == 0) {
      out << "pointclouds: []\n";
    } else {
      out << "pointclouds:\n";
      for (auto item : msg.pointclouds) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PointClouds & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_msgs::msg::PointClouds & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_msgs::msg::PointClouds & msg)
{
  return situational_graphs_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_msgs::msg::PointClouds>()
{
  return "situational_graphs_msgs::msg::PointClouds";
}

template<>
inline const char * name<situational_graphs_msgs::msg::PointClouds>()
{
  return "situational_graphs_msgs/msg/PointClouds";
}

template<>
struct has_fixed_size<situational_graphs_msgs::msg::PointClouds>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_msgs::msg::PointClouds>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_msgs::msg::PointClouds>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__POINT_CLOUDS__TRAITS_HPP_
