// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from situational_graphs_msgs:msg/PointClouds.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "situational_graphs_msgs/msg/detail/point_clouds__functions.h"
#include "situational_graphs_msgs/msg/detail/point_clouds__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace situational_graphs_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PointClouds_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) situational_graphs_msgs::msg::PointClouds(_init);
}

void PointClouds_fini_function(void * message_memory)
{
  auto typed_message = static_cast<situational_graphs_msgs::msg::PointClouds *>(message_memory);
  typed_message->~PointClouds();
}

size_t size_function__PointClouds__pointclouds(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<sensor_msgs::msg::PointCloud2> *>(untyped_member);
  return member->size();
}

const void * get_const_function__PointClouds__pointclouds(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<sensor_msgs::msg::PointCloud2> *>(untyped_member);
  return &member[index];
}

void * get_function__PointClouds__pointclouds(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<sensor_msgs::msg::PointCloud2> *>(untyped_member);
  return &member[index];
}

void fetch_function__PointClouds__pointclouds(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const sensor_msgs::msg::PointCloud2 *>(
    get_const_function__PointClouds__pointclouds(untyped_member, index));
  auto & value = *reinterpret_cast<sensor_msgs::msg::PointCloud2 *>(untyped_value);
  value = item;
}

void assign_function__PointClouds__pointclouds(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<sensor_msgs::msg::PointCloud2 *>(
    get_function__PointClouds__pointclouds(untyped_member, index));
  const auto & value = *reinterpret_cast<const sensor_msgs::msg::PointCloud2 *>(untyped_value);
  item = value;
}

void resize_function__PointClouds__pointclouds(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<sensor_msgs::msg::PointCloud2> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PointClouds_message_member_array[2] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_msgs::msg::PointClouds, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "pointclouds",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sensor_msgs::msg::PointCloud2>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_msgs::msg::PointClouds, pointclouds),  // bytes offset in struct
    nullptr,  // default value
    size_function__PointClouds__pointclouds,  // size() function pointer
    get_const_function__PointClouds__pointclouds,  // get_const(index) function pointer
    get_function__PointClouds__pointclouds,  // get(index) function pointer
    fetch_function__PointClouds__pointclouds,  // fetch(index, &value) function pointer
    assign_function__PointClouds__pointclouds,  // assign(index, value) function pointer
    resize_function__PointClouds__pointclouds  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PointClouds_message_members = {
  "situational_graphs_msgs::msg",  // message namespace
  "PointClouds",  // message name
  2,  // number of fields
  sizeof(situational_graphs_msgs::msg::PointClouds),
  PointClouds_message_member_array,  // message members
  PointClouds_init_function,  // function to initialize message memory (memory has to be allocated)
  PointClouds_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PointClouds_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PointClouds_message_members,
  get_message_typesupport_handle_function,
  &situational_graphs_msgs__msg__PointClouds__get_type_hash,
  &situational_graphs_msgs__msg__PointClouds__get_type_description,
  &situational_graphs_msgs__msg__PointClouds__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace situational_graphs_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<situational_graphs_msgs::msg::PointClouds>()
{
  return &::situational_graphs_msgs::msg::rosidl_typesupport_introspection_cpp::PointClouds_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, situational_graphs_msgs, msg, PointClouds)() {
  return &::situational_graphs_msgs::msg::rosidl_typesupport_introspection_cpp::PointClouds_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
