// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from situational_graphs_msgs:msg/RoomData.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_H_
#define SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'neighbour_ids'
#include "rosidl_runtime_c/primitives_sequence.h"
// Member 'room_length'
// Member 'cluster_center'
#include "geometry_msgs/msg/detail/point__struct.h"
// Member 'room_center'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'x_planes'
// Member 'y_planes'
#include "situational_graphs_msgs/msg/detail/plane_data__struct.h"
// Member 'cluster_array'
#include "visualization_msgs/msg/detail/marker_array__struct.h"

/// Struct defined in msg/RoomData in the package situational_graphs_msgs.
typedef struct situational_graphs_msgs__msg__RoomData
{
  std_msgs__msg__Header header;
  int32_t id;
  rosidl_runtime_c__int32__Sequence neighbour_ids;
  geometry_msgs__msg__Point room_length;
  geometry_msgs__msg__Pose room_center;
  geometry_msgs__msg__Point cluster_center;
  situational_graphs_msgs__msg__PlaneData__Sequence x_planes;
  situational_graphs_msgs__msg__PlaneData__Sequence y_planes;
  visualization_msgs__msg__MarkerArray cluster_array;
} situational_graphs_msgs__msg__RoomData;

// Struct for a sequence of situational_graphs_msgs__msg__RoomData.
typedef struct situational_graphs_msgs__msg__RoomData__Sequence
{
  situational_graphs_msgs__msg__RoomData * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} situational_graphs_msgs__msg__RoomData__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SITUATIONAL_GRAPHS_MSGS__MSG__DETAIL__ROOM_DATA__STRUCT_H_
