// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_msgs:msg/WallsData.idl
// generated code does not contain a copyright notice
#include "situational_graphs_msgs/msg/detail/walls_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `walls`
#include "situational_graphs_msgs/msg/detail/wall_data__functions.h"

bool
situational_graphs_msgs__msg__WallsData__init(situational_graphs_msgs__msg__WallsData * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    situational_graphs_msgs__msg__WallsData__fini(msg);
    return false;
  }
  // walls
  if (!situational_graphs_msgs__msg__WallData__Sequence__init(&msg->walls, 0)) {
    situational_graphs_msgs__msg__WallsData__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_msgs__msg__WallsData__fini(situational_graphs_msgs__msg__WallsData * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // walls
  situational_graphs_msgs__msg__WallData__Sequence__fini(&msg->walls);
}

bool
situational_graphs_msgs__msg__WallsData__are_equal(const situational_graphs_msgs__msg__WallsData * lhs, const situational_graphs_msgs__msg__WallsData * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // walls
  if (!situational_graphs_msgs__msg__WallData__Sequence__are_equal(
      &(lhs->walls), &(rhs->walls)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_msgs__msg__WallsData__copy(
  const situational_graphs_msgs__msg__WallsData * input,
  situational_graphs_msgs__msg__WallsData * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // walls
  if (!situational_graphs_msgs__msg__WallData__Sequence__copy(
      &(input->walls), &(output->walls)))
  {
    return false;
  }
  return true;
}

situational_graphs_msgs__msg__WallsData *
situational_graphs_msgs__msg__WallsData__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__WallsData * msg = (situational_graphs_msgs__msg__WallsData *)allocator.allocate(sizeof(situational_graphs_msgs__msg__WallsData), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_msgs__msg__WallsData));
  bool success = situational_graphs_msgs__msg__WallsData__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_msgs__msg__WallsData__destroy(situational_graphs_msgs__msg__WallsData * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_msgs__msg__WallsData__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_msgs__msg__WallsData__Sequence__init(situational_graphs_msgs__msg__WallsData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__WallsData * data = NULL;

  if (size) {
    data = (situational_graphs_msgs__msg__WallsData *)allocator.zero_allocate(size, sizeof(situational_graphs_msgs__msg__WallsData), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_msgs__msg__WallsData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_msgs__msg__WallsData__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_msgs__msg__WallsData__Sequence__fini(situational_graphs_msgs__msg__WallsData__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_msgs__msg__WallsData__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_msgs__msg__WallsData__Sequence *
situational_graphs_msgs__msg__WallsData__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_msgs__msg__WallsData__Sequence * array = (situational_graphs_msgs__msg__WallsData__Sequence *)allocator.allocate(sizeof(situational_graphs_msgs__msg__WallsData__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_msgs__msg__WallsData__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_msgs__msg__WallsData__Sequence__destroy(situational_graphs_msgs__msg__WallsData__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_msgs__msg__WallsData__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_msgs__msg__WallsData__Sequence__are_equal(const situational_graphs_msgs__msg__WallsData__Sequence * lhs, const situational_graphs_msgs__msg__WallsData__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_msgs__msg__WallsData__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_msgs__msg__WallsData__Sequence__copy(
  const situational_graphs_msgs__msg__WallsData__Sequence * input,
  situational_graphs_msgs__msg__WallsData__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_msgs__msg__WallsData);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_msgs__msg__WallsData * data =
      (situational_graphs_msgs__msg__WallsData *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_msgs__msg__WallsData__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_msgs__msg__WallsData__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_msgs__msg__WallsData__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
