// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_msgs:srv/LoadGraph.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__LOAD_GRAPH__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__LOAD_GRAPH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Request __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Request __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct LoadGraph_Request_
{
  using Type = LoadGraph_Request_<ContainerAllocator>;

  explicit LoadGraph_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->destination = "";
    }
  }

  explicit LoadGraph_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : destination(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->destination = "";
    }
  }

  // field types and members
  using _destination_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _destination_type destination;

  // setters for named parameter idiom
  Type & set__destination(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->destination = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Request
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Request
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LoadGraph_Request_ & other) const
  {
    if (this->destination != other.destination) {
      return false;
    }
    return true;
  }
  bool operator!=(const LoadGraph_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LoadGraph_Request_

// alias to use template instance with default allocator
using LoadGraph_Request =
  situational_graphs_msgs::srv::LoadGraph_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace situational_graphs_msgs


#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Response __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Response __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct LoadGraph_Response_
{
  using Type = LoadGraph_Response_<ContainerAllocator>;

  explicit LoadGraph_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit LoadGraph_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Response
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Response
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LoadGraph_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const LoadGraph_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LoadGraph_Response_

// alias to use template instance with default allocator
using LoadGraph_Response =
  situational_graphs_msgs::srv::LoadGraph_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace situational_graphs_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Event __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Event __declspec(deprecated)
#endif

namespace situational_graphs_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct LoadGraph_Event_
{
  using Type = LoadGraph_Event_<ContainerAllocator>;

  explicit LoadGraph_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit LoadGraph_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::srv::LoadGraph_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_msgs::srv::LoadGraph_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Event
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_msgs__srv__LoadGraph_Event
    std::shared_ptr<situational_graphs_msgs::srv::LoadGraph_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const LoadGraph_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const LoadGraph_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct LoadGraph_Event_

// alias to use template instance with default allocator
using LoadGraph_Event =
  situational_graphs_msgs::srv::LoadGraph_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace situational_graphs_msgs

namespace situational_graphs_msgs
{

namespace srv
{

struct LoadGraph
{
  using Request = situational_graphs_msgs::srv::LoadGraph_Request;
  using Response = situational_graphs_msgs::srv::LoadGraph_Response;
  using Event = situational_graphs_msgs::srv::LoadGraph_Event;
};

}  // namespace srv

}  // namespace situational_graphs_msgs

#endif  // SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__LOAD_GRAPH__STRUCT_HPP_
