// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from situational_graphs_msgs:srv/SaveMap.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__STRUCT_H_
#define SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'destination'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SaveMap in the package situational_graphs_msgs.
typedef struct situational_graphs_msgs__srv__SaveMap_Request
{
  bool utm;
  float resolution;
  rosidl_runtime_c__String destination;
} situational_graphs_msgs__srv__SaveMap_Request;

// Struct for a sequence of situational_graphs_msgs__srv__SaveMap_Request.
typedef struct situational_graphs_msgs__srv__SaveMap_Request__Sequence
{
  situational_graphs_msgs__srv__SaveMap_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} situational_graphs_msgs__srv__SaveMap_Request__Sequence;

// Constants defined in the message

/// Struct defined in srv/SaveMap in the package situational_graphs_msgs.
typedef struct situational_graphs_msgs__srv__SaveMap_Response
{
  bool success;
} situational_graphs_msgs__srv__SaveMap_Response;

// Struct for a sequence of situational_graphs_msgs__srv__SaveMap_Response.
typedef struct situational_graphs_msgs__srv__SaveMap_Response__Sequence
{
  situational_graphs_msgs__srv__SaveMap_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} situational_graphs_msgs__srv__SaveMap_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  situational_graphs_msgs__srv__SaveMap_Event__request__MAX_SIZE = 1
};
// response
enum
{
  situational_graphs_msgs__srv__SaveMap_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SaveMap in the package situational_graphs_msgs.
typedef struct situational_graphs_msgs__srv__SaveMap_Event
{
  service_msgs__msg__ServiceEventInfo info;
  situational_graphs_msgs__srv__SaveMap_Request__Sequence request;
  situational_graphs_msgs__srv__SaveMap_Response__Sequence response;
} situational_graphs_msgs__srv__SaveMap_Event;

// Struct for a sequence of situational_graphs_msgs__srv__SaveMap_Event.
typedef struct situational_graphs_msgs__srv__SaveMap_Event__Sequence
{
  situational_graphs_msgs__srv__SaveMap_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} situational_graphs_msgs__srv__SaveMap_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SITUATIONAL_GRAPHS_MSGS__SRV__DETAIL__SAVE_MAP__STRUCT_H_
